#include "Fase.h"
#include <iostream>
using namespace std;

Fase::Fase(BITMAP &bmp, BITMAP &cob, int j, int fase, Player &p1, Player &p2){
    this->buffer = &bmp;
    this->cobertura = &cob;
    this->delay = 0;
    this->delay2 = 0;
    this->posMovel = -480;
    this->jogadores = j;
    this->gameOver = false;
    this->faseConcluida = false;
    if(fase == 1){
        this->background = load_bitmap("./cenario/fase1.bmp", NULL);
        this->backMovel = load_bitmap("./cenario/fase1movel.bmp", NULL);
        this->chao = load_bitmap("./cenario/chao1.bmp", NULL);
        this->gMuro = new GerenciadorMuro(1);
        this->gSeta1 = new GerenciadorSetas(1, 1);
        if(jogadores == 2)
        	this->gSeta2 = new GerenciadorSetas(1, 2);
    }else{
        this->background = load_bitmap("./cenario/fase2.bmp", NULL);
        this->backMovel = load_bitmap("./cenario/fase2movel.bmp", NULL);
        this->chao = load_bitmap("./cenario/chao1.bmp", NULL);
        this->gMuro = new GerenciadorMuro(2);
        this->gSeta1 = new GerenciadorSetas(2, 1);
       	if(jogadores == 2)
        	this->gSeta2 = new GerenciadorSetas(2, 2);
    }
    this->player1 = &p1;
    
    if(jogadores == 2)
        this->player2 = &p2;
}

Fase::~Fase(){
	destroy_bitmap(background);
	destroy_bitmap(backMovel);
	destroy_bitmap(chao);
	destroy_bitmap(buffer);
	destroy_bitmap(proximaFase);
	destroy_bitmap(cobertura);
	if(gMuro){
		delete gMuro;
		gMuro = 0;
	}
	if (player1){
		delete player1;
		player1 = 0;
	}
	if (player2){
		delete player2;
		player2 = 0;
	}
}

void Fase::processar(bool flag){

    draw_sprite(this->buffer, this->background, 0, 0);
    draw_sprite(this->buffer, this->backMovel, 141, this->posMovel);
    this->moverCenario(5);
    this->gMuro->start(*this->buffer);
    if(!player1->morto()){
    	this->gSeta1->manipularSetas(*this->buffer, *this->player1, this->faseConcluida);
    	this->gSeta1->setContadoresTempo();
    	this->gSeta1->colisaoSeta(*this->buffer);
    }else{
    	player1->matar();
    	if(player1->getPorcentagem() > 0)
    		player1->zerarHP();
    }
   	if(jogadores == 2){
    	if(!player2->morto()){
	    	this->gSeta2->manipularSetas(*this->buffer, *this->player2, this->faseConcluida);
	    	this->gSeta2->setContadoresTempo();
	    	this->gSeta2->colisaoSeta(*this->buffer);
    	}else{
    		player2->matar();
    		if(player2->getPorcentagem() > 0)
    			player2->zerarHP();
    	}
    }
    this->gameOver = this->player1->processar();
    if(this->jogadores == 2)
        this->gameOver &= this->player2->processar();
    draw_sprite(this->buffer, this->chao, 141, 451-chao->h);
    if(key[KEY_F5] && !flag)
        this->faseConcluida = true;
}


void Fase::terminarFase(){
    draw_sprite(this->buffer, this->backMovel, 141, this->posMovel);
    this->acelerarCenario(5);
}

bool Fase::deuGameOver(){
    return this->gameOver;
}

bool Fase::passouFase(){
    return this->faseConcluida;
}

void Fase::moverCenario(int atraso){
    this->posMovel = this->posMovel + ((this->delay%(atraso+1))/atraso);
    if(this->posMovel >= 0)
        this->posMovel = -480;
    this->delay++;
}

void Fase::acelerarCenario(int velocidade){
    draw_sprite(this->buffer, this->backMovel, 141, this->posMovel);
    this->posMovel = this->posMovel + ((this->delay2)/velocidade);
    if(this->posMovel >= 0)
        this->posMovel = -480;
    this->delay2++;
}
