#include "Player.h"
#include "allegro.h"
#include "define.h"
#include <iostream>

Player::Player(BITMAP &bmp, BITMAP &cob, int jogador){
    int esq;
    int dir;
    this->cobertura = &cob;
    if(jogador == 1){
        esq = KEY_G;
        dir = KEY_H;
        posVidaX = VIDA1_X;
        posVidaY = VIDA1_Y;
    }else{
        esq = KEY_LEFT;
        dir = KEY_RIGHT;
        posVidaX = VIDA2_X;
        posVidaY = VIDA2_Y;
    }
    this->buffer = &bmp;
    this->vidas = create_bitmap(52,16);
    this->personagem = new Personagem(esq, dir, jogador);
    
     if(jogador == 1){
        this->sangue = new Sangue(*(this->cobertura), POSS1_X, POSS1_Y, POSB1_X, POSB1_Y);
        this->pontuacao = new Pontuacao(*(this->cobertura), POSP1_X, POSP1_Y);
        this->mush = load_bitmap("./vidas/redmush.bmp", NULL);
    }else{
        this->sangue = new Sangue(*(this->cobertura), POSS2_X, POSS2_Y, POSB2_X, POSB2_Y);
        this->pontuacao = new Pontuacao(*(this->cobertura), POSP2_X, POSP2_Y);
        this->mush = load_bitmap("./vidas/greenmush.bmp", NULL);
    }
}
Player::~Player(){
	destroy_bitmap(buffer);
	destroy_bitmap(vidas);
	destroy_bitmap(mush);
	destroy_bitmap(cobertura);
	if(personagem){
		delete personagem;
		personagem = 0;
	}	
	if(sangue){
		delete sangue;	
		sangue = 0;
	}
}

bool Player::processar(){
        this->pontuacao->desenhar(*cobertura);
        this->sangue->desenhar();

    if(!this->sangue->morto() && this->personagem->get_vidas() > 0){
        this->personagem->processar(*(this->buffer));
        draw_sprite(cobertura,desenharVidas(),posVidaX,posVidaY);
        return false;
    }//gameover
        this->pontuacao->zerarCombo();
        
        return true;
}

void Player::setaAcertada(){
    this->pontuacao->incrementarCombo();
    this->pontuacao->adicionarPontos(100);
    this->sangue->recuperarLife();
}

void Player::setaErrada(){
    this->pontuacao->zerarCombo();
    this->sangue->sofrerDano();
}

BITMAP* Player::desenharVidas(){
        int x = 0;
        clear(this->vidas);
        for(int i = 0; i < this->personagem->get_vidas(); i++){
            draw_sprite(this->vidas, this->mush, x,0);
            x = x + this->mush->w;
        }
        return this->vidas;

}
void Player::resetarVidas(){
	this->pontuacao->adicionarPontos(this->personagem->get_vidas()*10000 + this->sangue->getPorcentagem()*300);
	this->personagem->resetarVidas();
	this->sangue->resetarHP();
	this->pontuacao->zerarCombo();
}

int Player::getPontos(){
	return this->pontuacao->getPontos();
}

void Player::matar(){
	personagem->set_vidas(0);
}

bool Player::morto(){
	return personagem->get_vidas() == 0 || sangue->getPorcentagem() <= 0;	
}

void Player::zerarHP(){
	sangue->sofrerDano();
}

int Player::getPorcentagem(){
	return sangue->getPorcentagem();	
}