#include "Pontuacao.h"
#include <cstring>
#include <iostream>
Pontuacao::Pontuacao(BITMAP &bmp, int pX, int pY){
    this->pontos = 0;
    this->comboAtual = 0;
    this->comboMax = 0;
    this->multiplicador = 1;
    this->auxMult = 0;
    this->pontuacao = create_bitmap(158,24);
    this->screen = &bmp;
    this->posPX = pX;
    this->posPY = pY;
    this->noCombo = false;
}

Pontuacao::~Pontuacao(){
    destroy_bitmap(pontuacao);
    destroy_bitmap(screen);
}

void Pontuacao::adicionarPontos(int valor){
    this->pontos = this->pontos + (valor*this->multiplicador);
}

void Pontuacao::incrementarCombo(){
    this->noCombo = true;
    this->comboAtual++;
    if(this->comboAtual > this->comboMax)
        this->comboMax = this->comboAtual;
    if(this->comboAtual == 15*this->multiplicador && this->multiplicador <= 4){
        this->incrementarMult();
        this->auxMult++;
    }
}

void Pontuacao::incrementarMult(){
    this->multiplicador = this->multiplicador*2;
}

void Pontuacao::zerarCombo(){
    this->comboAtual = 0;
    this->zerarMult();
    this->noCombo = false;
    this->auxMult = 0;
}

void Pontuacao::zerarMult(){
    this->multiplicador = 1;
}


BITMAP* Pontuacao::decodificarPontos(){
	clear(this->pontuacao);
	textprintf_ex(this->pontuacao, font,0,0, makecol(255,255,255),-1, "Pontos: %d", pontos);
	textprintf_ex(this->pontuacao, font,0,8, makecol(255,255,255),-1, "Combo: ");
	textprintf_ex(this->pontuacao, font,0,16, makecol(255,255,255),-1, "Mult: ");	
	if(noCombo)
		textprintf_ex(this->pontuacao, font,50,8, makecol(255,255,255),-1, "%d", comboAtual);
	if(auxMult >=1)
		textprintf_ex(this->pontuacao, font,50,16, makecol(255,255,255),-1, "%d", multiplicador);
	return this->pontuacao;
}


void Pontuacao::desenhar(BITMAP &buffer){
        draw_sprite(&buffer, this->decodificarPontos(), this->posPX, this->posPY);
}

int Pontuacao::getPontos(){
	return this->pontos;
}